<template>
  <div class="app-container">
    <el-card class="topCard">
      <div class="topDiv">
        <el-button type="primary" icon="el-icon-circle-plus-outline" size="small" @click="addTo">新增</el-button>
      </div>
      <el-table
        ref="multipleTable"
        :data="tableData"
        :header-cell-style="{background:'#eef1f6',color:'#606266'}"
        :cell-class-name="tableRowClassName"
        height="680px"
        class="main"
        tooltip-effect="dark"
        style="width: 70%"
        border
        size="mini">
        <el-table-column align="center" width="60px" label="序号">
          <template slot-scope="scope">
            {{ scope.row.序号 }}
          </template>
        </el-table-column>
        <el-table-column label="检查内容" width="150px">
          <template slot-scope="scope">
            <div style="white-space: pre-line !important;">{{ scope.row.检查内容 }}</div>
          </template>
        </el-table-column>
        <el-table-column label="检查要求">
          <template slot-scope="scope">
            <div style="white-space: pre-line !important;">{{ scope.row.检查要求 }}</div>
          </template>
        </el-table-column>
        <el-table-column label="检查结果" width="150px">
          <template slot-scope="scope">
            <div style="white-space: pre-line !important;">{{ scope.row.检查结果 }}</div>
          </template>
        </el-table-column>
        <el-table-column align="center" label="操作" width="100">
          <template slot-scope="scope">
            <el-button type="text" @click="editInformation(scope.row)"><i class="el-icon-edit"/></el-button>
            <el-button type="text" style="color: #ff0000" @click="deleteInformation(scope.row)"><i class="el-icon-delete"/></el-button>
          </template>
        </el-table-column>
      </el-table>
    </el-card>
    <el-dialog :visible.sync="dialogFormVisible" :title="title" center style="min-height: 200px;" width="500px">
      <el-form ref="form" :model="form" :rules="rules" label-position="right" label-width="110px">
        <!--        <el-form-item label="工位号:" prop="stationNumber" style="display: inline-block">-->
        <!--          <el-select v-model="form.stationNumber" placeholder="请选择工位号" clearable size="small" style="width: 200px">-->
        <!--            <el-option-->
        <!--              v-for="item in stationNumber"-->
        <!--              :key="item.value"-->
        <!--              :label="item.label"-->
        <!--              :value="item.value"-->
        <!--              size="mini"/>-->
        <!--          </el-select>-->
        <!--        </el-form-item>-->
        <!--        <el-form-item label="产品型号:" prop="moduleDescription" style="display: inline-block">-->
        <!--          <el-select v-model="form.moduleDescription" placeholder="请选择产品型号" clearable size="small" style="width: 200px">-->
        <!--            <el-option-->
        <!--              v-for="item in engineType"-->
        <!--              :key="item.value"-->
        <!--              :label="item.label"-->
        <!--              :value="item.value"-->
        <!--              size="mini"/>-->
        <!--          </el-select>-->
        <!--        </el-form-item>-->
        <el-form-item label="序号" prop="number" style="display: inline-block">
          <el-input-number v-model="form.number" :min="1" :step="1" style="width:300px;" size="small"/>
        </el-form-item>
        <el-form-item label="检查内容:" prop="text" style="display: inline-block">
          <el-input
            v-model="form.text"
            :rows="2"
            type="textarea"
            clearable
            size="small"
            style="width: 300px"
            placeholder="请输入检查内容"/>
        </el-form-item>
        <el-form-item label="检查要求:" prop="work" style="display: inline-block">
          <el-input
            v-model="form.work"
            :rows="2"
            type="textarea"
            clearable
            size="small"
            style="width: 300px"
            placeholder="请输入检查要求"/>
        </el-form-item>
        <!--        <el-form-item label="要领:" prop="text" style="display: inline-block">-->
        <!--          <el-input-->
        <!--            v-model="form.fun"-->
        <!--            :rows="2"-->
        <!--            type="textarea"-->
        <!--            clearable-->
        <!--            size="small"-->
        <!--            style="width: 300px"-->
        <!--            placeholder="请输入要领"/>-->
        <!--        </el-form-item>-->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="small" @click="callOff('form')">取消</el-button>
        <el-button v-if="title === '添加'" type="primary" size="small" @click="submitAdd('form')">确定</el-button>
      </div>
    </el-dialog>
    <el-dialog :visible.sync="dialogFormVisible1" :title="title" center style="min-height: 200px;" width="500px">
      <el-form ref="form1" :model="form1" :rules="rules1" label-position="right" label-width="110px">
        <el-form-item label="序号:" prop="number" style="display: inline-block">
          <el-input-number v-model="form1.number" :min="1" :step="1" style="width:300px;" size="small"/>
        </el-form-item>
        <el-form-item label="检查内容:" prop="text" style="display: inline-block">
          <el-input
            v-model="form1.text"
            :rows="2"
            type="textarea"
            clearable
            size="small"
            style="width: 300px;"
            placeholder="请输入检查内容"/>
        </el-form-item>
        <el-form-item label="检查要求:" prop="work" style="display: inline-block">
          <el-input
            v-model="form1.work"
            :rows="2"
            type="textarea"
            clearable
            size="small"
            style="width: 300px"
            placeholder="请输入检查要求"/>
        </el-form-item>
        <!--        <el-form-item label="要领:" prop="text" style="display: inline-block">-->
        <!--          <el-input-->
        <!--            v-model="form1.fun"-->
        <!--            :rows="2"-->
        <!--            type="textarea"-->
        <!--            clearable-->
        <!--            size="small"-->
        <!--            style="width: 300px"-->
        <!--            placeholder="请输入要领"/>-->
        <!--        </el-form-item>-->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="small" @click="callOff1('form1')">取消</el-button>
        <el-button v-if="title === '编辑'" type="primary" size="small" @click="submitUpdate('form1')">确定</el-button>
      </div>
    </el-dialog>
    <el-dialog :visible.sync="dialogFormVisible4" title="数据复制" center style="min-height: 200px" width="400px">
      <el-form ref="form1" :model="form4" :rules="rules4" label-position="right" label-width="110px">
        <el-form-item label="工位号" prop="engineTypeValue" style="display: inline-block">
          <el-select v-model="form4.stationNumberValue" placeholder="请选择工位号" size="small">
            <el-option
              v-for="item in stationNumber"
              :key="item.value"
              :label="item.label"
              :value="item.value"
              size="mini"/>
          </el-select>
        </el-form-item>
        <el-form-item label="产品型号" prop="engineTypeValue" style="display: inline-block">
          <el-select v-model="form4.engineTypeValue" placeholder="请选择产品型号" size="small">
            <el-option
              v-for="item in engineType"
              :key="item.value"
              :label="item.label"
              :value="item.value"
              size="mini"/>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="small" @click="callOff4()">取消</el-button>
        <el-button type="primary" size="small" @click="submitAdd4()">确定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
export default {
  data() {
    return {
      tableData: [], // 总数据数组
      stationNumber: [],
      stationNumberValue: '',
      stationName: '',
      moduleDescription: [],
      moduleDescriptionValue: '',
      engineTypeValue: '',
      engineTypeValue1: '',
      engineTypeName: '',
      engineType: [],
      tagIDArr: [
        {
          label: 'lbl_datagrid_quality_name',
          value: 'lbl_datagrid_quality_name'
        }, {
          label: 'lbl_datagrid_quality_item1',
          value: 'lbl_datagrid_quality_item1'
        }, {
          label: 'lbl_datagrid_quality_item2',
          value: 'lbl_datagrid_quality_item2'
        }
      ],
      isDisable: [
        {
          label: '是',
          value: 1
        }, {
          label: '否',
          value: 0
        }
      ],
      isDisableValue: 0,
      labelText: '',
      labelNumber: '',
      dialogFormVisible: false,
      dialogFormVisible1: false,
      dialogFormVisible4: false,
      title: '',
      form: {
        stationNumber: '',
        moduleDescription: '',
        number: '',
        text: '',
        work: '', // 作业
        fun: '' // 要领
      },
      rules: {
        stationNumber: [{ required: true, message: '请选择工位号', trigger: 'change' }],
        moduleDescription: [{ required: true, message: '请选择产品型号', trigger: 'change' }],
        number: [{ required: true, message: '请输入序号', trigger: 'blur' }],
        text: [{ required: true, message: '请输入检查内容', trigger: 'blur' }],
        work: [{ required: true, message: '请输入检查要求', trigger: 'blur' }]
      },
      form1: {
        number: '',
        text: '',
        work: '',
        fun: ''
      },
      rules1: {
        number: [{ required: true, message: '请输入序号', trigger: 'blur' }],
        text: [{ required: true, message: '请输入操作内容', trigger: 'blur' }],
        work: [{ required: true, message: '请输入操作内容', trigger: 'blur' }]
      },
      form4: {
        engineTypeValue: '',
        stationNumberValue: ''
      },
      rules4: { // 订单下发验证
        engineTypeValue: [{ required: true, message: '请选择机型', trigger: 'blur' }],
        stationNumberValue: [{ required: true, message: '请选择工位号', trigger: 'blur' }]
      }
    }
  },
  computed: {
    ...mapGetters([
      'id',
      'token',
      'departmentName'
    ])
  },
  watch: {
    // stationNumberValue() {
    //   for (let i = 0; i < this.stationNumber.length; i++) {
    //     if (this.stationNumber[i].value === this.stationNumberValue) {
    //       console.log(this.stationNumber[i].label, 'this.stationNumber[i].label')
    //       this.stationName = this.stationNumber[i].labelName
    //     }
    //   }
    //   if (!this.stationNumberValue) {
    //     this.stationName = ''
    //   }
    // },
    engineTypeValue1() {
      console.log(1234)
      for (let i = 0; i < this.engineType.length; i++) {
        if (this.engineType[i].value === this.engineTypeValue1) {
          this.engineTypeName = this.engineType[i].labelName
          console.log(this.engineTypeName, 'this.engineTypeName')
        }
      }
    }
  },
  created() {
    // this.getStationNumber()
    // this.getEndStation()
  },
  mounted() {
    setTimeout(() => {
      this.searchTable()
    }, 300)
  },
  methods: {
    getStationNumber() {
      this.stationNumber = []
      var param = []
      var Data = this.CreateData('11', 'MES_计划BOM_工位与名称_查询', param)
      this.ExecDatabase(Data).then(response => {
        if (response.data.length) {
          this.stationNumberValue = response.data[0].工位号
          this.stationName = response.data[0].工位名称
        }
        for (let i = 0; i < response.data.length; i++) {
          this.stationNumber.push({
            label: `【${response.data[i].工位号}】${response.data[i].工位名称}`,
            value: response.data[i].工位号,
            labelName: response.data[i].工位名称
          })
        }
      })
    },
    // 初始化获取产品型号
    getEndStation() {
      this.engineType = []
      var param = []
      var Data = this.CreateData('11', 'CATL_基础信息_机型信息_查询', param)
      this.ExecDatabase(Data).then(response => {
        if (response.data.length > 0) this.engineTypeValue = response.data[0].机型ID
        for (let i = 0; i < response.data.length; i++) {
          this.engineType.push({
            label: response.data[i].机型号,
            value: response.data[i].机型ID,
            labelName: response.data[i].机型号
          })
        }
      })
    },
    // 表格颜色变化
    tableRowClassName({ row, rowIndex }) {
      // console.log(row, rowIndex)
      if (rowIndex % 2 === 0) {
        return 'black'
      } else {
        return 'red'
      }
    },
    // 查询MES消息
    searchTable() {
      this.tableData = []
      var param = []
      var Data = this.CreateData('11', 'CATL_基础_装车单检查内容_查询', param)
      this.ExecDatabase(Data).then(response => {
        if (response.data.length !== 0) {
          this.tableData = response.data
        }
      })
    },
    copyOrder(formName) {
      if (this.tableData.length) {
        if (this.$refs[formName] !== undefined) {
          this.$refs[formName].resetFields()
        }
        this.dialogFormVisible4 = true
      } else {
        this.$message({
          message: '暂无可复制的数据！',
          type: 'error'
        })
      }
    },
    async submitAdd4() {
      let number, text
      for (let i = 0; i < this.tableData.length; i++) {
        number = this.tableData[i].工步号
        text = this.tableData[i].操作内容
        await this.submitAdd5(number, text)
      }
      this.$message({
        message: '增加成功',
        type: 'success'
      })
      this.dialogFormVisible4 = false
      this.engineTypeValue = this.form4.engineTypeValue
      this.stationNumberValue = this.form4.stationNumberValue
      this.searchTable()
    },
    async submitAdd5(number, text) {
      var param = []
      param[0] = ['工位号', this.form4.stationNumberValue]
      param[1] = ['产品型号代码', this.form4.engineTypeValue]
      param[2] = ['工步号', number]
      param[3] = ['操作内容', text]
      param[4] = ['发动机型号', this.form4.engineTypeValue]
      var Data = this.CreateData('12', '电子看板_工序内容_增加', param)
      return new Promise((resolve, reject) => {
        this.ExecDatabase(Data).then(response => {
          if (response.data[0].result === '1') {
            console.log('1')
            resolve(1)
          } else {
            console.log('0')
            reject(2)
          }
        })
      })
    },
    callOff4() {
      this.dialogFormVisible4 = false
    },
    addTo() {
      this.title = '添加'
      this.dialogFormVisible = true
    },
    submitAdd(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          var param = []
          param[0] = ['序号', this.form.number]
          param[1] = ['检查内容', this.form.text]
          param[2] = ['检查要求', this.form.work]
          console.log(param)
          var Data = this.CreateData('12', 'CATL_基础_装车单检查内容_新增', param)
          this.ExecDatabase(Data).then(response => {
            if (response.data[0].result === '1') {
              this.$message({
                message: '增加成功',
                type: 'success'
              })
              this.dialogFormVisible = false
              this.searchTable()
            } else {
              this.$message.error('增加失败！')
            }
          })
        } else {
          return false
        }
      })
    },
    callOff() {
      this.dialogFormVisible = false
      this.$refs['form'].resetFields()
      this.form.stationNumber = ''
      this.form.moduleDescription = ''
      this.form.number = ''
      this.form.text = ''
      this.engineTypeName = ''
      this.title = ''
    },
    callOff1() {
      this.dialogFormVisible1 = false
      this.$refs['form1'].resetFields()
      this.form.stationNumber = ''
      this.form.moduleDescription = ''
      this.form.number = ''
      this.form.text = ''
      this.engineTypeName = ''
      this.title = ''
    },
    editInformation(row) {
      this.labelNumber = row.ID
      this.form1.number = row.序号
      this.form1.text = row.检查内容
      this.form1.work = row.检查要求
      this.title = '编辑'
      this.dialogFormVisible1 = true
    },
    // 编辑消息
    submitUpdate(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          var param = []
          param[0] = ['序号', this.form1.number]
          param[1] = ['检查内容', this.form1.text]
          param[2] = ['检查要求', this.form1.work]
          param[3] = ['ID', this.labelNumber]
          console.log(param)
          var Data = this.CreateData('12', 'CATL_基础_装车单检查内容_编辑', param)
          this.ExecDatabase(Data).then(response => {
            if (response.data[0].result === '1') {
              this.$message({
                message: '修改成功',
                type: 'success'
              })
              this.dialogFormVisible1 = false
              this.searchTable()
            } else {
              this.$message.error('修改失败！')
            }
          })
        } else {
          return false
        }
      })
    },
    deleteInformation(row) {
      this.$confirm('此操作将永久删除该行, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        var param = []
        param[0] = ['ID', row.ID]
        var Data = this.CreateData('12', 'CATL_基础_装车单检查内容_删除', param)
        this.ExecDatabase(Data).then(response => {
          if (response.data[0].result === '1') {
            this.$message({
              message: '删除成功',
              type: 'success'
            })
            this.searchTable()
          } else {
            this.$message.error('删除失败！')
          }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消删除'
        })
      })
    }
  }
}
</script>

<style scoped>
  .topCard{
    margin: 5px;
  }
  .topDiv{
    margin-bottom: 10px;
  }
  .el-select{
    width:200px
  }
  .el-input{
    width:200px
  }
  .text {
    font-size: 14px;
  }

  .item {
    padding: 18px 0;
  }

  .box-card {
    position: absolute;
    right: 6px;
    top: 80px;
    width: 300px;
  }
  .el-table .warning-row {
    background: oldlace;
  }

  .el-table .success-row {
    background: #f0f9eb;
  }

  ::v-deep.el-input.is-disabled .el-input__inner{
    color: #606266!important;
  }

  ::v-deep textarea{
    height: 100px;
  }
</style>

